#include <AccelStepper.h>
#include <spline.h>
#include "SPI.h"
#include <PS4BT.h>
#include <usbhub.h>

#ifdef dobogusinclude
#include <spi4teensy3.h>
#include <SPI.h>
#endif

//-------------Versionsnummer----------------
String versionNo = "30090";

//------USB-host-shield(PS4-controller)--------
USB Usb;
BTD Btd(&Usb);
//PS4BT PS4(&Btd, PAIR);
PS4BT PS4(&Btd);
bool printAngle, printTouch;
uint8_t oldL2Value, oldR2Value;

boolean moveUactive = false;
boolean moveVactive = false;
boolean moveWactive = false;
boolean moveXactive = false;
boolean moveYactive = false;
boolean moveZactive = false;


unsigned long prevMilliPS4u = 0;
unsigned long prevMilliPS4v = 0;
unsigned long prevMilliPS4w = 0;
unsigned long prevMilliPS4x = 0;
unsigned long prevMilliPS4y = 0;
unsigned long prevMilliPS4z = 0;

boolean ps4transmitdelayU = false;
boolean ps4transmitdelayV = false;
boolean ps4transmitdelayW = false;
boolean ps4transmitdelayX = false;
boolean ps4transmitdelayY = false;
boolean ps4transmitdelayZ = false;
unsigned long transmitMillisU = 0;
unsigned long transmitMillisV = 0;
unsigned long transmitMillisW = 0;
unsigned long transmitMillisX = 0;
unsigned long transmitMillisY = 0;
unsigned long transmitMillisZ = 0;

byte currentLEDcolor = 0;
byte ps4LEDmode = 0; // 0 = standard - 1=OFF - 2=White
byte joystickLeftMode = 1; // 0= both - 1=Xonly - 2=Vonly
byte joystickRightMode = 1; // 0= both - 1=Xonly - 2=Wonly



//-------------TMC2130 registers-------------
#define WRITE          0x80 //write flag
#define REG_GCONF      0x00
#define REG_GSTAT      0x01
#define REG_IHOLD_IRUN 0x10
#define REG_TPOWERDOWN 0x11
#define REG_CHOPCONF   0x6C
#define REG_COOLCONF   0x6D
#define REG_DCCTRL     0x6E
#define REG_DRVSTATUS  0x6F

char charvalue = '0';

//--------------IHOLDIRUN--------------
// 31 = 100%
char IHOLDIRUN[5];
uint32_t IHOLDIRUNvalue;

byte IHOLDu = 5;
byte IHOLDv = 5;
byte IHOLDw = 5;
byte IHOLDx = 5;
byte IHOLDy = 5;
byte IHOLDz = 5;

byte IRUNu = 7;
byte IRUNv = 7;
byte IRUNw = 21;
byte IRUNx = 21;
byte IRUNy = 21;
byte IRUNz = 21;

byte IHOLDDELAYall = 3;

//------------------Bluetooth----------------

String StringSend;
String myString;

String commandStr;

//-------------SPI-settings-----------------------
SPISettings settingsA(4000000, MSBFIRST, SPI_MODE3);

//-------------Defintion for AccelStepper-----------------
//----------------------Teensy 3.6------------------------








const int Uenable = 30;
const int Venable = 36;
const int Wenable = 38;
const int Xenable = 5;
const int Yenable = 8;
const int Zenable = 25;

const int Ucs = 29;
const int Vcs = 35;
const int Wcs = 37;
const int Xcs = 4;
const int Ycs = 9;
const int Zcs = 26;

const int Ustep = 28; //Pin 28
const int Udir = 27;//Pin 27
const int Vstep = 32;//Pin 32
const int Vdir = 31;//Pin 31
const int Wstep = 39; //Pin 39
const int Wdir = 14;//Pin 14
const int Xstep = 3;//Pin 3
const int Xdir = 2;//Pin 2
const int Ystep = 7;//Pin 7
const int Ydir = 6;//Pin 6
const int Zstep = 24;///Pin 24
const int Zdir = 10;//Pin 10

AccelStepper AccelStepperU(1, Ustep, Udir); // Drehen / STEP = 51 / DIR = 53
AccelStepper AccelStepperV(1, Vstep, Vdir); // Kippen / STEP = 43 / DIR = 45
AccelStepper AccelStepperW(1, Wstep, Wdir); // Slider / STEP = 29 / DIR = 31
AccelStepper AccelStepperX(1, Xstep, Xdir); // Kippen / STEP = 28 / DIR = 26
AccelStepper AccelStepperY(1, Ystep, Ydir); // Drehen / STEP = 4 / DIR = 5
AccelStepper AccelStepperZ(1, Zstep, Zdir); // Slider / STEP = 11 / DIR = 12



//------------------PIN-Definition general--------------------------

const int motorPowerEnable = 20;
const int voltageReadCam = A7;
const int voltageRead1 = A9;
const int voltageRead2 = A8;
const int readCameraTrigger = 15; // Slave-Mode
const int dslrTrigger = 19;
const int dslrFocus = 18;
const int enablePowerUSBhost = 17;
const int csUSBhost = 16;

//--------------------------------------------------------
bool stepperUactive = true;
bool stepperVactive = true;
bool stepperWactive = true;
bool stepperXactive = true;
bool stepperYactive = true;
bool stepperZactive = true;

long stepAmountU = 0;
long stepAmountV = 0;
long stepAmountW = 0;
long stepAmountX = 0;
long stepAmountY = 0;
long stepAmountZ = 0;



//-----------Definition Splines----------
Spline tempCurveU;
Spline tempCurveV;
Spline tempCurveW;
Spline tempCurveX;
Spline tempCurveY;
Spline tempCurveZ;


float n7[7] = {
  0, 0, 0, 0, 0, 0, 0
};
float u7[7] = {
  0, 0, 0, 0, 0, 0, 0
};
float v7[7] = {
  0, 0, 0, 0, 0, 0, 0
};
float w7[7] = {
  0, 0, 0, 0, 0, 0, 0
};
float x7[7] = {
  0, 0, 0, 0, 0, 0, 0
};
float y7[7] = {
  0, 0, 0, 0, 0, 0, 0
};
float z7[7] = {
  0, 0, 0, 0, 0, 0, 0
};

long tempGerundetU = 0;
long tempGerundetV = 0;
long tempGerundetW = 0;
long tempGerundetX = 0;
long tempGerundetY = 0;
long tempGerundetZ = 0;

//--------Spline-Positions---------


float P4u = 0;
float P4v = 0;
float P4w = 0;
float P4x = 0;
float P4y = 0;
float P4z = 0;

int currentKeyframe = 0;

//-------------Defintion Battery-Check-----------------
int returnCamVolt = 0;
int voltage1;
int voltage2;
int voltageCam;

long currentMillisDelay = 0;
long timepassed = 0;

long bildanzahlAKTdslr = 0;
long bildanzahl = 0;
int bildanzahlToGo = 0;
byte runinreverse = 0;
//----------Slave-Input-------------------------
unsigned long lastDebounceTime = 0;
unsigned long debounceDelay = 2;

int buttonState = LOW;
int lastButtonState = LOW;

int slaveTrigger = 0;
int slaveTouchbuttonClick = 0;

//------------STEPPER Configuration------------

//Steps for 360° turn
long stepperUres = 200;
long stepperVres = 200;
long stepperWres = 200;
long stepperXres = 200;
long stepperYres = 200;
long stepperZres = 200;

//Set Stepper resolution for setup mode
int UsetupRES = 16;
int VsetupRES = 16;
int WsetupRES = 16;
int XsetupRES = 16;
int YsetupRES = 16;
int ZsetupRES = 16;

// Backlash compensation (Only for reverse play)
int Ubacklash = 0;
int Vbacklash = 0;
int Wbacklash = 0;
int Xbacklash = 0;
int Ybacklash = 0;
int Zbacklash = 0;

// Speed setting for stepper movement
long speedU = 3500;
long speedV = 3500;
long speedW = 3500;
long speedX = 3500;
long speedY = 3500;
long speedZ = 3500;

// Speed setting for stepper movement
long speedUps4 = 0;
long speedVps4 = 0;
long speedWps4 = 0;
long speedXps4 = 0;
long speedYps4 = 0;
long speedZps4 = 0;

// Speed setting for stepper movement
long maxManualSpeedU = 10;
long maxManualSpeedV = 10;
long maxManualSpeedW = 10;
long maxManualSpeedX = 10;
long maxManualSpeedY = 10;
long maxManualSpeedZ = 10;


// Current speed during acceleration (manual move)
long currentSpeedU = 0;
long currentSpeedV = 0;
long currentSpeedW = 0;
long currentSpeedX = 0;
long currentSpeedY = 0;
long currentSpeedZ = 0;

// Invert Direction of axis
int invertDirectionU = 0;
int invertDirectionV = 0;
int invertDirectionW = 0;
int invertDirectionX = 0;
int invertDirectionY = 0;
int invertDirectionZ = 0;


// Acceleration during manual move
int manualAccelU = 300;
int manualAccelV = 300;
int manualAccelW = 300;
int manualAccelX = 300;
int manualAccelY = 300;
int manualAccelZ = 300;



// Acceleration amount for shot-move-shot and pano
long accelerationAmountU = 0;
long accelerationAmountV = 0;
long accelerationAmountW = 0;
long accelerationAmountX = 0;
long accelerationAmountY = 0;
long accelerationAmountZ = 0;




long sliderLength = 83000; //full-steps 1,3m
bool resetKeyframes = true;
//------------------Video-Function----------------

unsigned long currentMillisVidArray = 0;
unsigned long previousMillisVidArray = 0;
long posii = 0;
long deltaVidArray = 0;

int videoPointUpdateTime = 40;
float timedurationVid = 0;
long movieLengthSeconds = 0;

long myArrayU[3705];
long myArrayV[3705];
long myArrayW[3705];
long myArrayX[3705];
long myArrayY[3705];
long myArrayZ[3705];

int videoMaxMoveSpeedU = 0;
int videoMaxMoveSpeedV = 0;
int videoMaxMoveSpeedW = 0;
int videoMaxMoveSpeedX = 0;
int videoMaxMoveSpeedY = 0;
int videoMaxMoveSpeedZ = 0;

int accellU = 0;
int accellV = 0;
int accellW = 0;
int accellX = 0;
int accellY = 0;
int accellZ = 0;

bool moveHomeMovie = false;


//------------------ motionType ------------------
//0: 5-point  -- 1: Linear with Fade -- 2: Linear
int motionType = 0; 
int motionTypeU = 0; 
int motionTypeV = 0; 
int motionTypeW = 0; 
int motionTypeX = 0; 
int motionTypeY = 0; 
int motionTypeZ = 0; 


//-----------------TIMELAPSE------------------------

int delayStartSeconds = 0;
int delayStartMill = 0;
int delayStartSecondsPassed = 0;
int delayStartSecondsRemain = 0;

int shotMode = 0; // 0=Slave - 1=Master

long TLinterval = 1000; //interval in 1/1000-Sekunden
int TLdelay = 0; //Verzögerung in 1/1000-Sekunden
int TLmaxexpo = 0;
long totalPicNo = 0;
long totalPicNoAKTmoveSpline = 0;
long currentPicNo = 0;
int totalPicNoToGo = 0;
long prozent = 0;
int noMoveShots = 0;
int TLende = 0;
int sliderDIR = 0; // 0 = to Motor - 1 = from Motor
int sliderMODE = 1; // 0 = full lenght - 1 = individual lenght

float totalMovePicNoFLOAT = 0;
int totalMovePicNo = 0;
unsigned long previousMillis2 = 0;
unsigned long previousMillis = 0;

unsigned long SMSdauer = 0;
int SMSstep = 0;

float FADEposition = 0.2; // Fadingposition for linear movement in percent 0.1 = 10 %
float FADEspeed = 0.1; // Fadingspeed for linear movement in percent 0.1 = 10 %

//------------PANO---------------------

long PanoHorizontalMoveSteps = 0;
long PanoVerticalMoveSteps = 0;

int panoRows = 0;
int panoColumns = 0;

int panoCurrentRow = 1;
int panoCurrentColumn = 1;

int panoCurrentPic = 0;
int panoTotalPicAmount = 0;

int PANOstepsX = 0;
int PANOstepsY = 0;

int currentRow = 1;
int currentColumn = 1;
float currentColumnFLOAT = 0;
float currentRowFLOAT = 0;

int ColumnEnd = 1;

int PanoChangeDirectionHori = 1;

int panoNextRow = 0;
//------------current Mode active-------------
bool movehome = false;
boolean moveKeyframe = false;
boolean keyframeMovement = true;
boolean startTL = false;
boolean startMovie = false;
boolean startAstro = false;
boolean startPano = false;
boolean pausePano = false;
boolean pauseTL = false;
boolean startPanoVertical = false;
String panoMode = "";
boolean movieFinished = false;

//------------manual move-------------------
long currentManualSpeed = 0;

int runU = 0;
int runV = 0;
int runW = 0;
int runX = 0;
int runY = 0;
int runZ = 0;

unsigned long DecelerationMillis;
unsigned long DecelerationMillisPREV;
long moveUdeceleration = 0;
long moveVdeceleration = 0;
long moveWdeceleration = 0;
long moveXdeceleration = 0;
long moveYdeceleration = 0;
long moveZdeceleration = 0;

double decelerationSpeeduDouble = 20;
double decelerationSpeedvDouble = 20;
double decelerationSpeedwDouble = 20;
double decelerationSpeedxDouble = 20;
double decelerationSpeedyDouble = 20;
double decelerationSpeedzDouble = 20;
int decelerationSpeeduINT = 20;
int decelerationSpeedvINT = 20;
int decelerationSpeedwINT = 20;
int decelerationSpeedxINT = 20;
int decelerationSpeedyINT = 20;
int decelerationSpeedzINT = 20;

int currentSelectedKeyframe = 0;
String currentSelectedAxis = "A";
boolean keyframeStartnew = true;
boolean keyframe1new = true;
boolean keyframe2new = true;
boolean keyframe3new = true;
boolean keyframeEndnew = true;

//-----------ASTRO--------------------
unsigned long AstroUpdateInterval = 8543; // update interval of steps in [micros]
byte AstroStartDelay = 3; // delay time before first picture after start in [s]
int AstroExpoTime01 = 1; // HDR1 exposure time in [s]
int AstroExpoTime02 = 0; // HDR2 exposure time in [s]
int AstroExpoTime03 = 0; // HDR3 exposure time in [s]
int AstroExpo01delay = 3; // delay after HDR1 exposure in [s]
int AstroExpo02delay = 0; // delay after HDR2 exposure in [s]
int AstroExpo03delay = 0; // delay after HDR3 exposure in [s]
int AstroPicRepete = 10;
int AstroPicCurrentRepeat = 0;
bool astroPicActive = false;
int AstroObject = 0;

//-------------Manual move---------------
int currentSpeedU02 = 0;
int lastSpeedU = 0;
int lastSpeedU02 = 0;

int currentSpeedV02 = 0;
int lastSpeedV = 0;
int lastSpeedV02 = 0;

int currentSpeedW02 = 0;
int lastSpeedW = 0;
int lastSpeedW02 = 0;

int currentSpeedX02 = 0;
int lastSpeedX = 0;
int lastSpeedX02 = 0;

int currentSpeedY02 = 0;
int lastSpeedY = 0;
int lastSpeedY02 = 0;

int currentSpeedZ02 = 0;
int lastSpeedZ = 0;
int lastSpeedZ02 = 0;


//--------------PS4-controller-speeds----------------
// Speed setting for stepper movement
double speedUd = 7000;
double  speedVd = 7000;
double speedWd = 7000;
double  speedXd = 7000;
double  speedYd = 7000;
double  speedZd = 7000;

int controlSpeed = 10;

double speedFactor = 1;

void setup()
{

  delay(500);
  //---------Accelstepper-Pins--------------

  pinMode(Ustep, OUTPUT);
  pinMode(Udir, OUTPUT);
  pinMode(Vstep, OUTPUT);
  pinMode(Vdir, OUTPUT);
  pinMode(Wstep, OUTPUT);
  pinMode(Wdir, OUTPUT);
  pinMode(Xstep, OUTPUT);
  pinMode(Xdir, OUTPUT);
  pinMode(Ystep, OUTPUT);
  pinMode(Ydir, OUTPUT);
  pinMode(Zstep, OUTPUT);
  pinMode(Zdir, OUTPUT);
  pinMode (enablePowerUSBhost, OUTPUT);
  pinMode (csUSBhost, OUTPUT);

  delay(200);
  digitalWrite(enablePowerUSBhost, HIGH);
  digitalWrite(csUSBhost, HIGH);
  delay(200);

  pinMode(Uenable, OUTPUT);
  pinMode(Venable, OUTPUT);
  pinMode(Wenable, OUTPUT);
  pinMode(Xenable, OUTPUT);
  pinMode(Yenable, OUTPUT);
  pinMode(Zenable, OUTPUT);


  pinMode (readCameraTrigger, INPUT);

  pinMode (voltageRead1, INPUT);
  pinMode (voltageRead2, INPUT);
  pinMode (voltageCam, INPUT);

  pinMode (dslrTrigger, OUTPUT);
  pinMode (dslrFocus, OUTPUT);

  pinMode(motorPowerEnable, OUTPUT);
  digitalWrite(motorPowerEnable, LOW);
  digitalWrite(dslrTrigger, LOW);
  digitalWrite(dslrFocus, LOW);

  digitalWrite(Uenable, HIGH);
  digitalWrite(Venable, HIGH);
  digitalWrite(Wenable, HIGH);
  digitalWrite(Xenable, HIGH);
  digitalWrite(Yenable, HIGH);
  digitalWrite(Zenable, HIGH);

#if !defined(__MIPSEL__)
  // while (!Serial); // Wait for serial port to connect - used on Leonardo, Teensy and other boards with built-in USB CDC serial connection
#endif
  if (Usb.Init() == -1) {
    //  Serial.print(F("\r\nOSC did not start"));
    while (1); //halt
  }






  //disable drivers
  setUmode(0);
  setVmode(0);
  setWmode(0);
  setXmode(0);
  setYmode(0);
  setZmode(0);


  analogReadResolution(13);

  AccelStepperU.setMaxSpeed(speedU);
  AccelStepperV.setMaxSpeed(speedV);
  AccelStepperW.setMaxSpeed(speedW);
  AccelStepperX.setMaxSpeed(speedX);
  AccelStepperY.setMaxSpeed(speedY);
  AccelStepperZ.setMaxSpeed(speedZ);

  //set minimum pulse width to 4 µs
  AccelStepperU.setMinPulseWidth(4);
  AccelStepperV.setMinPulseWidth(4);
  AccelStepperW.setMinPulseWidth(4);
  AccelStepperX.setMinPulseWidth(4);
  AccelStepperY.setMinPulseWidth(4);
  AccelStepperZ.setMinPulseWidth(4);



 // Serial.begin(19200);

  Serial5.begin(9600);

  Serial5.flush();

  pinMode(Ucs, OUTPUT);
  digitalWrite(Ucs, HIGH);
  pinMode(Vcs, OUTPUT);
  digitalWrite(Vcs, HIGH);
  pinMode(Wcs, OUTPUT);
  digitalWrite(Wcs, HIGH);
  pinMode(Xcs, OUTPUT);
  digitalWrite(Xcs, HIGH);
  pinMode(Ycs, OUTPUT);
  digitalWrite(Ycs, HIGH);
  pinMode(Zcs, OUTPUT);
  digitalWrite(Zcs, HIGH);






  SPI.begin();


  previousMillisVidArray = millis();



}



void loop()
{
  // Serial.println("0000");
  if (runU == 2 || runV == 2 || runW == 2 || runX == 2 || runY == 2 || runZ == 2) {
    //  Serial.println("1111");
    //---------------manual move---------------------
    //------Run U------

    if (runU == 2) {
      AccelStepperU.setSpeed(currentSpeedU);
      AccelStepperU.runSpeed();
    }
    //------Run X------

    if (runV == 2) {
      AccelStepperV.setSpeed(currentSpeedV);
      AccelStepperV.runSpeed();
    }
    //------Run W------

    if (runW == 2) {
      AccelStepperW.setSpeed(currentSpeedW);
      AccelStepperW.runSpeed();
    }
    //------Run X------

    if (runX == 2) {
      AccelStepperX.setSpeed(currentSpeedX);
      AccelStepperX.runSpeed();
      //Serial.print("currentManualSpeed:");
      // Serial.println(currentManualSpeed);
    }
    //------Run Y------

    if (runY == 2) {
      AccelStepperY.setSpeed(currentSpeedY);
      AccelStepperY.runSpeed();
    }
    //------Run Z------

    if (runZ == 2) {
      AccelStepperZ.setSpeed(currentSpeedZ);
      AccelStepperZ.runSpeed();
    }
  }
  else if (moveHomeMovie == false && moveKeyframe == false && movehome == false && startAstro == false && startPano == false && startPanoVertical == false && startTL == false && startMovie == false) {
    PS4controllerfunction();
    // Serial.println("2222");
  }
  else {
    //   Serial.println("3333");
    PS4disconnect();
    if (startAstro == true) {
      astroloop();
    }
    if (movehome == true) {
      //Serial.println("movehomemovehome");
      setMaxSpeedSteppers();
      moveBackToStart();
    }

    if (moveKeyframe == true) {
      // Serial.println("movekeyframe");
      setMaxSpeedSteppers();
      moveToKeyframe();
    }

    if (moveHomeMovie == true) {
      //   Serial.println("movehomemovie");
      setMaxSpeedSteppers();
      moveBackToStartMovie();
    }


    if (startTL == true) {
      //  Serial.println("startTL");
      unsigned long currentMillis = millis();

      if (delayStartSeconds == 0) {
        timelapseMaster();
      }

      else {
        if (currentMillis - timepassed > 1000) {
          delayStartSecondsPassed++;
          delayStartSecondsRemain = delayStartSeconds - delayStartSecondsPassed;

          myString = String(delayStartSecondsRemain);
          StringSend = "#delayStartRe_" + myString + "$";
          Serial5.print(StringSend);
          // Serial.println(StringSend);

          if (delayStartSecondsPassed == delayStartSeconds) {
            delay(50);
            StringSend = "#delayStartRe_0$" ;
            Serial5.print(StringSend);
            delay(50);
            delayStartSeconds = 0;
          }
          timepassed = currentMillis;
        }
      }
    }
    if (startMovie == true) {
      Splinevideoloop();
    }

    if (startPano == true) {

      PanoLoop();
    }
    if (startPanoVertical == true) {
      PanoLoopVertical();
    }
  }

  if (Serial5.available()) {

    char c = Serial5.read();
    // Serial.println("hallo");
    if (c == '#') {
      parseCommand(commandStr);
      //   Serial.println(commandStr);
      commandStr = "";
    }
    else {
      commandStr += c;
    }
  }
}


void parseCommand(String com) {
  //  Serial.println(com);
  String part1;
  String part2;
  int no;

  part1 = com.substring(0, com.indexOf("_"));
  part2 = com.substring(com.indexOf("_") + 1, com.length());

  no = part1.toInt();
  readBT(no, part2);

}



void readBT(int BTvar, String BTvalue)
{

  float intervalFloat = 0;
  float MaxExpoFloat = 0;
  switch (BTvar) {

    case 1001:

      if (BTvalue == "1") {
        StepperEnable();
        delay(50);
        StepperEnable();



      }
      if (BTvalue == "0") {
        StepperStop();
      }
      if (BTvalue == "2") {
        StepperStop();
        currentPicNo = totalPicNo - 1;
        panoCurrentPic = panoTotalPicAmount;
      }

      break;

    case 1002:
      PS4.pair();
      break;

    case 1003:
      PS4disconnect();
      break;

    case 1007:
      currentManualSpeed = BTvalue.toInt();
      if (currentManualSpeed == 0) {

        while (currentSpeedU != 0) {
          DecelerationMillis = micros();

          if (currentSpeedU > 0) {
            if ((DecelerationMillis - DecelerationMillisPREV) >= decelerationSpeeduINT)
            {

              currentSpeedU--;
              DecelerationMillisPREV = micros();
            }
          }
          else {
            if ((DecelerationMillis - DecelerationMillisPREV) >= decelerationSpeeduINT)
            {

              currentSpeedU++;
              DecelerationMillisPREV = micros();
            }
          }


          AccelStepperU.setSpeed(currentSpeedU);
          AccelStepperU.runSpeed();

        }

        runU = 0;
        currentSpeedU = 0;
        AccelStepperU.setSpeed(speedU);


        myString = String(AccelStepperU.currentPosition());
        StringSend = "#curPosU_" + myString + "$";
        Serial5.print(StringSend);

        switch (currentKeyframe) {
          case 0:
            break;

          case 1:
            u7[0] = AccelStepperU.currentPosition();
            u7[2] = AccelStepperU.currentPosition();

             if (keyframe2new == true) {
                u7[3] = AccelStepperU.currentPosition();
               u7[4] = AccelStepperU.currentPosition();
               u7[5] = AccelStepperU.currentPosition();
               u7[6] = AccelStepperU.currentPosition();
              }
            break;

          case 2:
            u7[3] = AccelStepperU.currentPosition();
            if (keyframe3new == true) {
               
               u7[4] = AccelStepperU.currentPosition();
               u7[5] = AccelStepperU.currentPosition();
               u7[6] = AccelStepperU.currentPosition();
              }
            break;

          case 3:
            u7[4] = AccelStepperU.currentPosition();
            u7[6] = AccelStepperU.currentPosition();
            
            if (keyframeEndnew == true) {
               u7[5] = AccelStepperU.currentPosition();
               u7[6] = AccelStepperU.currentPosition();
              }
            break;

          case 4:
            u7[5] = AccelStepperU.currentPosition();
            break;

        }
     
      }
      else {
        currentSpeedU = currentManualSpeed;
        lastSpeedU02 = currentManualSpeed;
        runU = 2;
      }

      break;

    case 1008:
      currentManualSpeed = BTvalue.toInt();
      if (currentManualSpeed == 0) {

        while (currentSpeedV != 0) {
          DecelerationMillis = micros();

          if (currentSpeedV > 0) {
            if ((DecelerationMillis - DecelerationMillisPREV) >= decelerationSpeedvINT)
            {

              currentSpeedV--;
              DecelerationMillisPREV = micros();
            }
          }
          else {
            if ((DecelerationMillis - DecelerationMillisPREV) >= decelerationSpeedvINT)
            {

              currentSpeedV++;
              DecelerationMillisPREV = micros();
            }
          }

          AccelStepperV.setSpeed(currentSpeedV);
          AccelStepperV.runSpeed();

        }


        runV = 0;
        currentSpeedV = 0;
        AccelStepperV.setSpeed(speedV);
        myString = String(AccelStepperV.currentPosition());
        StringSend = "#curPosV_" + myString + "$";
        Serial5.print(StringSend);
        switch (currentKeyframe) {
          case 0:
            break;

          case 1:
            v7[0] = AccelStepperV.currentPosition();
            v7[2] = AccelStepperV.currentPosition();

             if (keyframe2new == true) {
                v7[3] = AccelStepperV.currentPosition();
               v7[4] = AccelStepperV.currentPosition();
               v7[5] = AccelStepperV.currentPosition();
               v7[6] = AccelStepperV.currentPosition();
              }
            break;

          case 2:
            v7[3] = AccelStepperV.currentPosition();
            if (keyframe3new == true) {
               
               v7[4] = AccelStepperV.currentPosition();
               v7[5] = AccelStepperV.currentPosition();
               v7[6] = AccelStepperV.currentPosition();
              }
            break;

          case 3:
            v7[4] = AccelStepperV.currentPosition();
            v7[6] = AccelStepperV.currentPosition();
            
            if (keyframeEndnew == true) {
               v7[5] = AccelStepperV.currentPosition();
               v7[6] = AccelStepperV.currentPosition();
              }
            break;

          case 4:
            v7[5] = AccelStepperV.currentPosition();
            break;

        }
      }
      else {
        currentSpeedV = currentManualSpeed;
        lastSpeedV02 = currentManualSpeed;
        runV = 2;
      }

      break;

    case 1009:
      currentManualSpeed = BTvalue.toInt();
      if (currentManualSpeed == 0) {

        while (currentSpeedW != 0) {
          DecelerationMillis = micros();

          if (currentSpeedW > 0) {
            if ((DecelerationMillis - DecelerationMillisPREV) >= decelerationSpeedwINT)
            {

              currentSpeedW--;
              DecelerationMillisPREV = micros();
            }
          }
          else {
            if ((DecelerationMillis - DecelerationMillisPREV) >= decelerationSpeedwINT)
            {

              currentSpeedW++;
              DecelerationMillisPREV = micros();
            }
          }

          AccelStepperW.setSpeed(currentSpeedW);
          AccelStepperW.runSpeed();

        }


        runW = 0;
        currentSpeedW = 0;
        AccelStepperW.setSpeed(speedW);
        myString = String(AccelStepperW.currentPosition());
        StringSend = "#curPosW_" + myString + "$";
        Serial5.print(StringSend);

        switch (currentKeyframe) {
          case 0:
            break;

          case 1:
            w7[0] = AccelStepperW.currentPosition();
            w7[2] = AccelStepperW.currentPosition();

             if (keyframe2new == true) {
                w7[3] = AccelStepperW.currentPosition();
               w7[4] = AccelStepperW.currentPosition();
               w7[5] = AccelStepperW.currentPosition();
               w7[6] = AccelStepperW.currentPosition();
              }
            break;

          case 2:
            w7[3] = AccelStepperW.currentPosition();
            if (keyframe3new == true) {
               
               w7[4] = AccelStepperW.currentPosition();
               w7[5] = AccelStepperW.currentPosition();
               w7[6] = AccelStepperW.currentPosition();
              }
            break;

          case 3:
            w7[4] = AccelStepperW.currentPosition();
            w7[6] = AccelStepperW.currentPosition();
            
            if (keyframeEndnew == true) {
               w7[5] = AccelStepperW.currentPosition();
               w7[6] = AccelStepperW.currentPosition();
              }
            break;

          case 4:
            w7[5] = AccelStepperW.currentPosition();
            break;

        }

      }
      else {
        currentSpeedW = currentManualSpeed;
        lastSpeedW02 = currentManualSpeed;
        runW = 2;
      }

      break;



    case 1010:
      currentManualSpeed = BTvalue.toInt();

      if (currentManualSpeed == 0) {



        while (currentSpeedX != 0) {
          DecelerationMillis = micros();

          if (currentSpeedX > 0) {
            if ((DecelerationMillis - DecelerationMillisPREV) >= decelerationSpeedxINT)
            {

              currentSpeedX--;
              DecelerationMillisPREV = micros();
            }
          }
          else {
            if ((DecelerationMillis - DecelerationMillisPREV) >= decelerationSpeedxINT)
            {

              currentSpeedX++;
              DecelerationMillisPREV = micros();
            }
          }

          AccelStepperX.setSpeed(currentSpeedX);
         // Serial.print("currentSpeedX:");
         // Serial.println(currentSpeedX);
          AccelStepperX.runSpeed();

        }


        runX = 0;
        currentSpeedX = 0;
        AccelStepperX.setSpeed(speedX);
        myString = String(AccelStepperX.currentPosition());
        StringSend = "#curPosX_" + myString + "$";
        Serial5.print(StringSend);

        switch (currentKeyframe) {
          case 0:
            break;

          case 1:
            x7[0] = AccelStepperX.currentPosition();
            x7[2] = AccelStepperX.currentPosition();

             if (keyframe2new == true) {
                x7[3] = AccelStepperX.currentPosition();
               x7[4] = AccelStepperX.currentPosition();
               x7[5] = AccelStepperX.currentPosition();
               x7[6] = AccelStepperX.currentPosition();
              }
            break;

          case 2:
            x7[3] = AccelStepperX.currentPosition();
            if (keyframe3new == true) {
               
               x7[4] = AccelStepperX.currentPosition();
               x7[5] = AccelStepperX.currentPosition();
               x7[6] = AccelStepperX.currentPosition();
              }
            break;

          case 3:
            x7[4] = AccelStepperX.currentPosition();
            x7[6] = AccelStepperX.currentPosition();
            
            if (keyframeEndnew == true) {
               x7[5] = AccelStepperX.currentPosition();
               x7[6] = AccelStepperX.currentPosition();
              }
            break;

          case 4:
            x7[5] = AccelStepperX.currentPosition();
            break;

        }
      }
      else {
        currentSpeedX = currentManualSpeed;
        lastSpeedX02 = currentManualSpeed;
        runX = 2;
      }

      break;

    case 1011:
      currentManualSpeed = BTvalue.toInt();
      if (currentManualSpeed == 0) {

        while (currentSpeedY != 0) {
          DecelerationMillis = micros();


          if (currentSpeedY > 0) {
            if ((DecelerationMillis - DecelerationMillisPREV) >= decelerationSpeedyINT)
            {

              currentSpeedY--;
              DecelerationMillisPREV = micros();
            }
          }
          else {
            if ((DecelerationMillis - DecelerationMillisPREV) >= decelerationSpeedyINT)
            {

              currentSpeedY++;
              DecelerationMillisPREV = micros();
            }
          }
          AccelStepperY.setSpeed(currentSpeedY);
          AccelStepperY.runSpeed();

        }


        runY = 0;
        currentSpeedY = 0;

        AccelStepperY.setSpeed(speedY);
        myString = String(AccelStepperY.currentPosition());
        StringSend = "#curPosY_" + myString + "$";
        Serial5.print(StringSend);

        switch (currentKeyframe) {
          case 0:
            break;

          case 1:
            y7[0] = AccelStepperY.currentPosition();
            y7[2] = AccelStepperY.currentPosition();

             if (keyframe2new == true) {
                y7[3] = AccelStepperY.currentPosition();
               y7[4] = AccelStepperY.currentPosition();
               y7[5] = AccelStepperY.currentPosition();
               y7[6] = AccelStepperY.currentPosition();
              }
            break;

          case 2:
            y7[3] = AccelStepperY.currentPosition();
            if (keyframe3new == true) {
               
               y7[4] = AccelStepperY.currentPosition();
               y7[5] = AccelStepperY.currentPosition();
               y7[6] = AccelStepperY.currentPosition();
              }
            break;

          case 3:
            y7[4] = AccelStepperY.currentPosition();
            y7[6] = AccelStepperY.currentPosition();
            
            if (keyframeEndnew == true) {
               y7[5] = AccelStepperY.currentPosition();
               y7[6] = AccelStepperY.currentPosition();
              }
            break;

          case 4:
            y7[5] = AccelStepperY.currentPosition();
            break;

        }

      }
      else {
        currentSpeedY = currentManualSpeed;
        lastSpeedY02 = currentManualSpeed;
        runY = 2;
      }

      break;

    case 1012:
      currentManualSpeed = BTvalue.toInt();
      if (currentManualSpeed == 0) {

        while (currentSpeedZ != 0) {
          DecelerationMillis = micros();

          if (currentSpeedZ > 0) {
            if ((DecelerationMillis - DecelerationMillisPREV) >= decelerationSpeedzINT)
            {

              currentSpeedZ--;
              DecelerationMillisPREV = micros();
            }
          }
          else {
            if ((DecelerationMillis - DecelerationMillisPREV) >= decelerationSpeedzINT)
            {

              currentSpeedZ++;
              DecelerationMillisPREV = micros();
            }
          }
          AccelStepperZ.setSpeed(currentSpeedZ);
          AccelStepperZ.runSpeed();

        }


        runZ = 0;
        currentSpeedZ = 0;
        AccelStepperZ.setSpeed(speedZ);
        myString = String(AccelStepperZ.currentPosition());
        StringSend = "#curPosZ_" + myString + "$";
        Serial5.print(StringSend);


         switch (currentKeyframe) {
          case 0:
            break;

          case 1:
            z7[0] = AccelStepperZ.currentPosition();
            z7[2] = AccelStepperZ.currentPosition();

             if (keyframe2new == true) {
                z7[3] = AccelStepperZ.currentPosition();
               z7[4] = AccelStepperZ.currentPosition();
               z7[5] = AccelStepperZ.currentPosition();
               z7[6] = AccelStepperZ.currentPosition();
              }
            break;

          case 2:
            z7[3] = AccelStepperZ.currentPosition();
            if (keyframe3new == true) {
               
               z7[4] = AccelStepperZ.currentPosition();
               z7[5] = AccelStepperZ.currentPosition();
               z7[6] = AccelStepperZ.currentPosition();
              }
            break;

          case 3:
            z7[4] = AccelStepperZ.currentPosition();
            z7[6] = AccelStepperZ.currentPosition();
            
            if (keyframeEndnew == true) {
               z7[5] = AccelStepperZ.currentPosition();
               z7[6] = AccelStepperZ.currentPosition();
              }
            break;

          case 4:
            z7[5] = AccelStepperZ.currentPosition();
            break;

        }

      }
      else {
        currentSpeedZ = currentManualSpeed;
        lastSpeedZ02 = currentManualSpeed;
        runZ = 2;
      }

      break;

    case 1020:
      u7[0] = u7[0] - AccelStepperU.currentPosition();
      u7[1] = 0;
      u7[2] = u7[2] - AccelStepperU.currentPosition();
      u7[3] = u7[3] - AccelStepperU.currentPosition();
      u7[4] = u7[4] - AccelStepperU.currentPosition();
      u7[5] = u7[5] - AccelStepperU.currentPosition();
      u7[6] = u7[6] - AccelStepperU.currentPosition();

      v7[0] = v7[0] - AccelStepperV.currentPosition();
      v7[1] = 0;
      v7[2] = v7[2] - AccelStepperV.currentPosition();
      v7[3] = v7[3] - AccelStepperV.currentPosition();
      v7[4] = v7[4] - AccelStepperV.currentPosition();
      v7[5] = v7[5] - AccelStepperV.currentPosition();
      v7[6] = v7[6] - AccelStepperV.currentPosition();

      w7[0] = w7[0] - AccelStepperW.currentPosition();
      w7[1] = 0;
      w7[2] = w7[2] - AccelStepperW.currentPosition();
      w7[3] = w7[3] - AccelStepperW.currentPosition();
      w7[4] = w7[4] - AccelStepperW.currentPosition();
      w7[5] = w7[5] - AccelStepperW.currentPosition();
      w7[6] = w7[6] - AccelStepperW.currentPosition();

      x7[0] = x7[0] - AccelStepperX.currentPosition();
      x7[1] = 0;
      x7[2] = x7[2] - AccelStepperX.currentPosition();
      x7[3] = x7[3] - AccelStepperX.currentPosition();
      x7[4] = x7[4] - AccelStepperX.currentPosition();
      x7[5] = x7[5] - AccelStepperX.currentPosition();
      x7[6] = x7[6] - AccelStepperX.currentPosition();

      y7[0] = y7[0] - AccelStepperY.currentPosition();
      y7[1] = 0;
      y7[2] = y7[2] - AccelStepperY.currentPosition();
      y7[3] = y7[3] - AccelStepperY.currentPosition();
      y7[4] = y7[4] - AccelStepperY.currentPosition();
      y7[5] = y7[5] - AccelStepperY.currentPosition();
      y7[6] = y7[6] - AccelStepperY.currentPosition();

      z7[0] = z7[0] - AccelStepperZ.currentPosition();
      z7[1] = 0;
      z7[2] = z7[2] - AccelStepperZ.currentPosition();
      z7[3] = z7[3] - AccelStepperZ.currentPosition();
      z7[4] = z7[4] - AccelStepperZ.currentPosition();
      z7[5] = z7[5] - AccelStepperZ.currentPosition();
      z7[6] = z7[6] - AccelStepperZ.currentPosition();

      AccelStepperU.setCurrentPosition(0);
      AccelStepperV.setCurrentPosition(0);
      AccelStepperW.setCurrentPosition(0);
      AccelStepperX.setCurrentPosition(0);
      AccelStepperY.setCurrentPosition(0);
      AccelStepperZ.setCurrentPosition(0);
      /*
            myString = String(AccelStepperU.currentPosition());
            StringSend = "#curPosU_" + myString + "$";
            Serial5.print(StringSend);

            delay(20);
            myString = String(AccelStepperV.currentPosition());
            StringSend = "#curPosV_" + myString + "$";
            Serial5.print(StringSend);

            delay(20);
            myString = String(AccelStepperW.currentPosition());
            StringSend = "#curPosW_" + myString + "$";
            Serial5.print(StringSend);

            delay(20);
            myString = String(AccelStepperX.currentPosition());
            StringSend = "#curPosX_" + myString + "$";
            Serial5.print(StringSend);

            delay(20);
            myString = String(AccelStepperY.currentPosition());
            StringSend = "#curPosY_" + myString + "$";
            Serial5.print(StringSend);


            delay(20);
            myString = String(AccelStepperZ.currentPosition());
            StringSend = "#curPosZ_" + myString + "$";
            Serial5.print(StringSend);

      */
      break;


    case 1030:
      /*
        P4u = AccelStepperU.currentPosition();
        P4v = AccelStepperV.currentPosition();
        P4w = AccelStepperW.currentPosition();
        P4x = AccelStepperX.currentPosition();
        P4y = AccelStepperY.currentPosition();
        P4z = AccelStepperZ.currentPosition();
      */
      break;

    case 1031:
      /*
        P4u = 0;
        P4v = 0;
        P4w = 0;
        P4x = 0;
        P4y = 0;

        if (BTvalue == "1") {
          P4z = -sliderLength * ZsetupRES;
        }
        else {
          P4z = sliderLength * ZsetupRES;
        }
      */
      break;


    case 1040:
      AccelStepperU.moveTo(0);
      AccelStepperV.moveTo(0);
      AccelStepperW.moveTo(0);
      AccelStepperX.moveTo(0);
      AccelStepperY.moveTo(0);
      AccelStepperZ.moveTo(0);
      movehome = true;
      break;

    case 1050:
      totalPicNo = BTvalue.toInt();
      // Serial.print("totalPicNo:");
      // Serial.println(totalPicNo);
      break;

    case 1051:
      noMoveShots = BTvalue.toInt();
      break;

    case 1060:
      BTvalue.replace(',', '.');
      intervalFloat = 1000 * (BTvalue.toFloat());
      TLinterval = (int) intervalFloat;
      break;

    case 1065:
      TLdelay = BTvalue.toInt();

      //  Serial.print("1065");
      // Serial.println(TLdelay);
      break;

    case 1070:
      returnvalues();
      break;


    case 1085:
      movieLengthSeconds = BTvalue.toInt();
      /*
            if (P4u > 0) {
              speedU = P4u / movieLengthSeconds;
            }
            if (P4v > 0) {
              speedV = P4v / movieLengthSeconds;
            }
            if (P4w > 0) {
              speedW = P4w / movieLengthSeconds;
            }
            if (P4x > 0) {
              speedX = P4x / movieLengthSeconds;
            }
            if (P4y > 0) {
              speedY = P4y / movieLengthSeconds;
            }
            if (P4z > 0) {
              speedZ = P4z / movieLengthSeconds;
            }

            if (P4u < 0) {
              speedU = -(P4u / movieLengthSeconds);
            }
            if (P4v < 0) {
              speedV = -(P4v / movieLengthSeconds);
            }
            if (P4w < 0) {
              speedW = -(P4w / movieLengthSeconds);
            }
            if (P4x < 0) {
              speedX = -(P4x / movieLengthSeconds);
            }
            if (P4y < 0) {
              speedY = -(P4y / movieLengthSeconds);
            }
            if (P4z < 0) {
              speedZ = -(P4z / movieLengthSeconds);
            }

            if (P4u == 0) {
              speedU = 3800;
            }
            if (P4v == 0) {
              speedV = 3800;
            }
            if (P4w == 0) {
              speedW = 3800;
            }
            if (P4x == 0) {
              speedX = 3800;
            }
            if (P4y == 0) {
              speedY = 3800;
            }
            if (P4z == 0) {
              speedZ = 3800;
            }
      */
      break;

    case 1090:

      delayStartSeconds = BTvalue.toInt();



      break;

    case 1115:
      runinreverse = BTvalue.toInt();

      tempGerundetU = AccelStepperU.currentPosition();
      tempGerundetV = AccelStepperV.currentPosition();
      tempGerundetW = AccelStepperW.currentPosition();
      tempGerundetX = AccelStepperX.currentPosition();
      tempGerundetY = AccelStepperY.currentPosition();
      tempGerundetZ = AccelStepperZ.currentPosition();
      break;

    case 1100:
      PS4disconnect();
      shotMode = BTvalue.toInt();
      /*
        Serial.println("-----POINTS1-----");
        Serial.println(x7[0]);
        Serial.println(x7[1]);
        Serial.println(x7[2]);
        Serial.println(x7[3]);
        Serial.println(x7[4]);
        Serial.println(x7[5]);
        Serial.println(x7[6]);
      */
      totalMovePicNo = totalPicNo - 2 * noMoveShots;

      totalMovePicNoFLOAT = (float) totalMovePicNo;
      // Serial.print("totalMovePicNo:");
      // Serial.println(totalMovePicNo);


      // Serial.print("motionType:");
      // Serial.println(motionType);
      switch (motionType) {
        case 0:
          n7[0] = -totalMovePicNoFLOAT * 0.25;
          n7[1] = 0;
          n7[2] = totalMovePicNoFLOAT * 0.25;
          n7[3] = totalMovePicNoFLOAT * 0.5;
          n7[4] = totalMovePicNoFLOAT * 0.75;
          n7[5] = totalMovePicNoFLOAT;
          n7[6] = totalMovePicNoFLOAT * 1.25;
          break;

        case 1:
          n7[0] = -totalMovePicNoFLOAT * FADEposition;
          n7[1] = 0;
          n7[2] = totalMovePicNoFLOAT * FADEposition;
          n7[3] = totalMovePicNoFLOAT * 0.5;
          n7[4] = totalMovePicNoFLOAT * (1 - FADEposition);
          n7[5] = totalMovePicNoFLOAT;
          n7[6] = totalMovePicNoFLOAT + (totalMovePicNoFLOAT * FADEposition);



          u7[0] = u7[5] * FADEspeed;
          u7[2] = u7[5] * FADEspeed;
          u7[3] = u7[5] * 0.5;
          u7[4] = u7[5] * (1 - FADEspeed);
          u7[6] = u7[5] - (u7[5] * FADEspeed);

          v7[0] = v7[5] * FADEspeed;
          v7[2] = v7[5] * FADEspeed;
          v7[3] = v7[5] * 0.5;
          v7[4] = v7[5] * (1 - FADEspeed);
          v7[6] = v7[5] - (v7[5] * FADEspeed);

          w7[0] = w7[5] * FADEspeed;
          w7[2] = w7[5] * FADEspeed;
          w7[3] = w7[5] * 0.5;
          w7[4] = w7[5] * (1 - FADEspeed);
          w7[6] = w7[5] - (w7[5] * FADEspeed);

          x7[0] = x7[5] * FADEspeed;
          x7[2] = x7[5] * FADEspeed;
          x7[3] = x7[5] * 0.5;
          x7[4] = x7[5] * (1 - FADEspeed);
          x7[6] = x7[5] - (x7[5] * FADEspeed);

          y7[0] = y7[5] * FADEspeed;
          y7[2] = y7[5] * FADEspeed;
          y7[3] = y7[5] * 0.5;
          y7[4] = y7[5] * (1 - FADEspeed);
          y7[6] = y7[5] - (y7[5] * FADEspeed);

          z7[0] = z7[5] * FADEspeed;
          z7[2] = z7[5] * FADEspeed;
          z7[3] = z7[5] * 0.5;
          z7[4] = z7[5] * (1 - FADEspeed);
          z7[6] = z7[5] - (z7[5] * FADEspeed);



          break;

        case 2:
          n7[0] = -totalMovePicNoFLOAT * 0.25;
          n7[1] = 0;
          n7[2] = totalMovePicNoFLOAT * 0.25;
          n7[3] = totalMovePicNoFLOAT * 0.5;
          n7[4] = totalMovePicNoFLOAT * 0.75;
          n7[5] = totalMovePicNoFLOAT;
          n7[6] = totalMovePicNoFLOAT * 1.25;


          u7[0] = u7[5] * -0.25;
          u7[2] = u7[5] * 0.25;
          u7[3] = u7[5] * 0.5;
          u7[4] = u7[5] * 0.75;
          u7[6] = u7[5] * 1.25;

          v7[0] = v7[5] * -0.25;
          v7[2] = v7[5] * 0.25;
          v7[3] = v7[5] * 0.5;
          v7[4] = v7[5] * 0.75;
          v7[6] = v7[5] * 1.25;

          w7[0] = w7[5] * -0.25;
          w7[2] = w7[5] * 0.25;
          w7[3] = w7[5] * 0.5;
          w7[4] = w7[5] * 0.75;
          w7[6] = w7[5] * 1.25;

          x7[0] = x7[5] * -0.25;
          x7[2] = x7[5] * 0.25;
          x7[3] = x7[5] * 0.5;
          x7[4] = x7[5] * 0.75;
          x7[6] = x7[5] * 1.25;

          y7[0] = y7[5] * -0.25;
          y7[2] = y7[5] * 0.25;
          y7[3] = y7[5] * 0.5;
          y7[4] = y7[5] * 0.75;
          y7[6] = y7[5] * 1.25;

          z7[0] = z7[5] * -0.25;
          z7[2] = z7[5] * 0.25;
          z7[3] = z7[5] * 0.5;
          z7[4] = z7[5] * 0.75;
          z7[6] = z7[5] * 1.25;
          break;

      }

      if (runinreverse == 1) {
        totalPicNoAKTmoveSpline = totalMovePicNoFLOAT + 1;
      }

      tempCurveU.setPoints(n7, u7, 7);
      tempCurveU.setDegree(Catmull);

      tempCurveV.setPoints(n7, v7, 7);
      tempCurveV.setDegree(Catmull);

      tempCurveW.setPoints(n7, w7, 7);
      tempCurveW.setDegree(Catmull);

      tempCurveX.setPoints(n7, x7, 7);
      tempCurveX.setDegree(Catmull);

      tempCurveY.setPoints(n7, y7, 7);
      tempCurveY.setDegree(Catmull);

      tempCurveZ.setPoints(n7, z7, 7);
      tempCurveZ.setDegree(Catmull);
      /*
        Serial.println("-----POINTS n-----");
        Serial.println(n7[0]);
        Serial.println(n7[1]);
        Serial.println(n7[2]);
        Serial.println(n7[3]);
        Serial.println(n7[4]);
        Serial.println(n7[5]);
        Serial.println(n7[6]);
        Serial.println("-----POINTS u-----");
        Serial.println(u7[0]);
        Serial.println(u7[1]);
        Serial.println(u7[2]);
        Serial.println(u7[3]);
        Serial.println(u7[4]);
        Serial.println(u7[5]);
        Serial.println(u7[6]);
      */

      TLmaxexpo = TLinterval - 200 - 200 - TLdelay;
      /*
            Serial.print("TLmaxexpo:");
            Serial.println(TLmaxexpo);
            Serial.print("TLinterval:");
            Serial.println(TLinterval);

      */

      //Must be set eventually!!!
      // moveSplineSMS();


      startTL = true;

      digitalWrite(dslrFocus, HIGH);
      delay(100);
      digitalWrite(dslrFocus, LOW);
      delay(600);


      break;

    case 1110:

      moveHomeMovie = true;

      break;

    case 1120:
      motionType = BTvalue.toInt();
      // Serial.print("motionType:");
      // Serial.println(motionType);

      break;

    case 1901:
      IHOLDu = BTvalue.toInt();
      break;
    case 1902:
      IHOLDv = BTvalue.toInt();
      break;
    case 1903:
      IHOLDw = BTvalue.toInt();
      break;
    case 1904:
      IHOLDx = BTvalue.toInt();
      break;
    case 1905:
      IHOLDy = BTvalue.toInt();
      break;
    case 1906:
      IHOLDz = BTvalue.toInt();
      break;
    case 1911:
      IRUNu = BTvalue.toInt();
      break;
    case 1912:
      IRUNv = BTvalue.toInt();
      break;
    case 1913:
      IRUNw = BTvalue.toInt();
      break;
    case 1914:
      IRUNx = BTvalue.toInt();
      break;
    case 1915:
      IRUNy = BTvalue.toInt();
      break;
    case 1916:
      IRUNz = BTvalue.toInt();
      break;

    case 1200:
      //setUresolution(BTvalue.toInt());
      UsetupRES = BTvalue.toInt();
      break;

    case 1210:
      //setVresolution(BTvalue.toInt());
      VsetupRES = BTvalue.toInt();
      break;

    case 1220:
      //setWresolution(BTvalue.toInt());
      WsetupRES = BTvalue.toInt();
      break;

    case 1230:
      //setXresolution(BTvalue.toInt());
      XsetupRES = BTvalue.toInt();
      break;

    case 1240:
      //setYresolution(BTvalue.toInt());
      YsetupRES = BTvalue.toInt();
      break;

    case 1250:
      // setZresolution(BTvalue.toInt());
      ZsetupRES = BTvalue.toInt();
      break;

    case 1260:
      if (BTvalue.toInt() == 0) {
        stepperUactive = false;
      }
      else {
        stepperUactive = true;
      }
      break;

    case 1261:
      if (BTvalue.toInt() == 0) {
        stepperVactive = false;
      }
      else {
        stepperVactive = true;
      }
      break;

    case 1262:
      if (BTvalue.toInt() == 0) {
        stepperWactive = false;
      }
      else {
        stepperWactive = true;
      }
      break;

    case 1263:
      if (BTvalue.toInt() == 0) {
        stepperXactive = false;
      }
      else {
        stepperXactive = true;
      }
      break;

    case 1264:
      if (BTvalue.toInt() == 0) {
        stepperYactive = false;
      }
      else {
        stepperYactive = true;
      }
      break;

    case 1265:
      if (BTvalue.toInt() == 0) {
        stepperZactive = false;
      }
      else {
        stepperZactive = true;
      }
      break;


    case 1301:
      stepAmountU = BTvalue.toInt();
      break;
    case 1302:
      stepAmountV = BTvalue.toInt();
      break;
    case 1303:
      stepAmountW = BTvalue.toInt();
      break;
    case 1304:
      stepAmountX = BTvalue.toInt();
      break;
    case 1305:
      stepAmountY = BTvalue.toInt();
      break;
    case 1306:
      stepAmountZ = BTvalue.toInt();
      break;

    case 1311:
      Ubacklash = BTvalue.toInt();
      break;
    case 1312:
      Vbacklash = BTvalue.toInt();
      break;
    case 1313:
      Wbacklash = BTvalue.toInt();
      break;
    case 1314:
      Xbacklash = BTvalue.toInt();
      break;
    case 1315:
      Ybacklash = BTvalue.toInt();
      break;
    case 1316:
      Zbacklash = BTvalue.toInt();
      break;


    case 1401:
      speedU = BTvalue.toInt();
      break;

    case 1402:
      speedV = BTvalue.toInt();
      break;

    case 1403:
      speedW = BTvalue.toInt();
      break;

    case 1404:
      speedX = BTvalue.toInt();
      break;

    case 1405:
      speedY = BTvalue.toInt();
      break;

    case 1406:
      speedZ = BTvalue.toInt();
      setMaxSpeedSteppers();
      break;

    case 1411:
      maxManualSpeedU = BTvalue.toInt();

      break;

    case 1412:
      maxManualSpeedV = BTvalue.toInt();

      break;

    case 1413:
      maxManualSpeedW = BTvalue.toInt();

      break;

    case 1414:
      maxManualSpeedX = BTvalue.toInt();

      break;

    case 1415:
      maxManualSpeedY = BTvalue.toInt();

      break;

    case 1416:
      maxManualSpeedZ = BTvalue.toInt();

      break;



    case 1431:
      if (BTvalue.toInt() == 1) {
        AccelStepperU.setPinsInverted(true, false, false);
      }
      else {
        AccelStepperU.setPinsInverted(false, false, false);
      }
      break;

    case 1432:
      if (BTvalue.toInt() == 1) {
        AccelStepperV.setPinsInverted(true, false, false);
      }
      else {
        AccelStepperV.setPinsInverted(false, false, false);
      }
      break;

    case 1433:
      if (BTvalue.toInt() == 1) {
        AccelStepperW.setPinsInverted(true, false, false);
      }
      else {
        AccelStepperW.setPinsInverted(false, false, false);
      }
      break;

    case 1434:
      if (BTvalue.toInt() == 1) {
        AccelStepperX.setPinsInverted(true, false, false);
      }
      else {
        AccelStepperX.setPinsInverted(false, false, false);
      }
      break;

    case 1435:
      if (BTvalue.toInt() == 1) {
        AccelStepperY.setPinsInverted(true, false, false);
      }
      else {
        AccelStepperY.setPinsInverted(false, false, false);
      }
      break;

    case 1436:
      if (BTvalue.toInt() == 1) {
        AccelStepperZ.setPinsInverted(true, false, false);
      }
      else {
        AccelStepperZ.setPinsInverted(false, false, false);
      }
      break;

    case 1441:

      manualAccelU = BTvalue.toInt();
      //acceleration and deceleration for manual move in µs
      decelerationSpeeduDouble = (manualAccelU * 1000 / maxManualSpeedU) + 0.5 ;
      decelerationSpeeduINT = (int)decelerationSpeeduDouble;
      break;

    case 1442:

      manualAccelV = BTvalue.toInt();
      //acceleration and deceleration for manual move in µs
      decelerationSpeedvDouble = (manualAccelV * 1000 / maxManualSpeedV) + 0.5 ;
      decelerationSpeedvINT = (int)decelerationSpeedvDouble;
      break;

    case 1443:

      manualAccelW = BTvalue.toInt();
      //acceleration and deceleration for manual move in µs
      decelerationSpeedwDouble = (manualAccelW * 1000 / maxManualSpeedW) + 0.5 ;
      decelerationSpeedwINT = (int)decelerationSpeedwDouble;
      break;

    case 1444:


      manualAccelX = BTvalue.toInt();
      //acceleration and deceleration for manual move in µs
      decelerationSpeedxDouble = (manualAccelX * 1000 / maxManualSpeedX) + 0.5 ;
      decelerationSpeedxINT = (int)decelerationSpeedxDouble;

      break;

    case 1445:

      manualAccelY = BTvalue.toInt();
      //acceleration and deceleration for manual move in µs
      decelerationSpeedyDouble = (manualAccelY * 1000 / maxManualSpeedY) + 0.5 ;
      decelerationSpeedyINT = (int)decelerationSpeedyDouble;
      break;

    case 1446:

      manualAccelZ = BTvalue.toInt();
      //acceleration and deceleration for manual move in µs
      decelerationSpeedzDouble = (manualAccelZ * 1000 / maxManualSpeedZ) + 0.5 ;
      decelerationSpeedzINT = (int)decelerationSpeedzDouble;

    
      break;

    case 1451:
      accelerationAmountU = BTvalue.toInt() * 100;
      break;

    case 1452:
      accelerationAmountV = BTvalue.toInt() * 100;
      break;

    case 1453:
      accelerationAmountW = BTvalue.toInt() * 100;
      break;

    case 1454:
      accelerationAmountX = BTvalue.toInt() * 100;
      break;

    case 1455:
      accelerationAmountY = BTvalue.toInt() * 100;
      break;

    case 1456:
      accelerationAmountZ = BTvalue.toInt() * 100;
      break;


    case 1500:
      slaveTouchbuttonClick = 1;
      break;

    case 1600:
      panoRows = BTvalue.toInt();
      break;

    case 1601:
      panoColumns = BTvalue.toInt();
      panoTotalPicAmount = panoRows * panoColumns;
      break;

    case 1610:
      PS4disconnect();
      BTvalue.replace(',', '.');
      MaxExpoFloat = 1000 * (BTvalue.toFloat());
      TLmaxexpo = 500 + (int) MaxExpoFloat;
      // Serial.print("MaxExpoFloat:");
      //Serial.println(MaxExpoFloat);
      // Serial.print("TLmaxexpo:");
      // Serial.println(TLmaxexpo);

      startPano = true;

      panoMode = "horizontal";
      panoCurrentPic = 0;
      currentRow = 1;
      currentColumn = 1;
      digitalWrite(dslrFocus, HIGH);
      delay(100);
      digitalWrite(dslrFocus, LOW);
      delay(600);
      break;

    case 1611:
      PS4disconnect();
      BTvalue.replace(',', '.');
      MaxExpoFloat = 1000 * (BTvalue.toFloat());
      TLmaxexpo = 500 + (int) MaxExpoFloat;
      // Serial.print("1611:");
      // Serial.println(TLmaxexpo);

      startPanoVertical = true;

      panoMode = "vertical";
      panoCurrentPic = 0;
      currentRow = 1;
      currentColumn = 1;
      digitalWrite(dslrFocus, HIGH);
      delay(100);
      digitalWrite(dslrFocus, LOW);
      delay(600);
      break;

    case 1615:
      PanoHorizontalMoveSteps = BTvalue.toInt();

      break;

    case 1616:
      PanoVerticalMoveSteps = BTvalue.toInt();

      break;

    case 1700:

      digitalWrite(dslrFocus, HIGH);
      digitalWrite(dslrTrigger, HIGH);
      delay(200);
      digitalWrite(dslrTrigger, LOW);
      digitalWrite(dslrFocus, LOW);
      break;

    case 1800:
      voltageCam = analogRead(voltageReadCam);
      myString = String(voltageCam);
      StringSend = "#voltageCam_" + myString + "$";
      Serial5.print(StringSend);

      break;

    case 1801:

      currentKeyframe = BTvalue.toInt();

      switch (currentKeyframe) {
        case 0:


          AccelStepperU.moveTo(0);
          AccelStepperV.moveTo(0);
          AccelStepperW.moveTo(0);
          AccelStepperX.moveTo(0);
          AccelStepperY.moveTo(0);
          AccelStepperZ.moveTo(0);
          if (keyframeMovement == true) {
            moveKeyframe = true;
          }
          break;

        case 1:

          if (keyframe1new == true) {
            if (keyframeMovement == true) {
              keyframe1new = false;

     
        
            }
          }
          else {


            AccelStepperU.moveTo(u7[2]);
            AccelStepperV.moveTo(v7[2]);
            AccelStepperW.moveTo(w7[2]);
            AccelStepperX.moveTo(x7[2]);
            AccelStepperY.moveTo(y7[2]);
            AccelStepperZ.moveTo(z7[2]);
            if (keyframeMovement == true) {
              moveKeyframe = true;
            }
          }
          break;
        case 2:

          if (keyframe2new == true) {
            if (keyframeMovement == true) {
              keyframe2new = false;
              
 
       
            }
          }
          else {


            AccelStepperU.moveTo(u7[3]);
            AccelStepperV.moveTo(v7[3]);
            AccelStepperW.moveTo(w7[3]);
            AccelStepperX.moveTo(x7[3]);
            AccelStepperY.moveTo(y7[3]);
            AccelStepperZ.moveTo(z7[3]);
            if (keyframeMovement == true) {
              moveKeyframe = true;
            }
          }
          break;
        case 3:

          if (keyframe3new == true) {
            if (keyframeMovement == true) {
              keyframe3new = false;
            }
          }
          else {


            AccelStepperU.moveTo(u7[4]);
            AccelStepperV.moveTo(v7[4]);
            AccelStepperW.moveTo(w7[4]);
            AccelStepperX.moveTo(x7[4]);
            AccelStepperY.moveTo(y7[4]);
            AccelStepperZ.moveTo(z7[4]);
            if (keyframeMovement == true) {
              moveKeyframe = true;
            }
          }
          break;
        case 4:

          if (keyframeEndnew == true) {
            // Serial.println("1111");
            if (keyframeMovement == true) {
              //   Serial.println("2222");
              keyframeEndnew = false;
            }
          }
          else {

            //  Serial.print("pos4:");
            // Serial.println(u7[5]);
            AccelStepperU.moveTo(u7[5]);
            AccelStepperV.moveTo(v7[5]);
            AccelStepperW.moveTo(w7[5]);
            AccelStepperX.moveTo(x7[5]);
            AccelStepperY.moveTo(y7[5]);
            AccelStepperZ.moveTo(z7[5]);
            if (keyframeMovement == true) {
              moveKeyframe = true;
            }
          }
          break;
      }



      break;


    case 1899:
      resetKeyframes = false;
      break;
    case 1900:
      videoPointUpdateTime = BTvalue.toInt();

      break;

    case 2000:
      PS4disconnect();
      motionType = BTvalue.toInt();


      setVideoData();
      transmitValues();


      break;


    case 3000:
      myString = String(versionNo);
      StringSend = "#versionNo_" + myString + "$";
      Serial5.print(StringSend);
      break;

    case 3010:
      myString = String(totalPicNo);
      StringSend = "#totalPicNo_" + myString + "$";
      Serial5.print(StringSend);
      break;

    case 3020:
      myString = String(TLinterval);
      StringSend = "#interval_" + myString + "$";
      Serial5.print(StringSend);
      break;

    case 3030:
      resetValues();
      break;

    //-----Preset-Transmit-----
    case 4010:
      u7[0] = BTvalue.toInt();
      u7[2] = BTvalue.toInt();
      break;

    case 4011:
      u7[3] = BTvalue.toInt();
      break;

    case 4012:
      u7[4] = BTvalue.toInt();
      u7[6] = BTvalue.toInt();
      break;

    case 4013:
      u7[5] = BTvalue.toInt();
      keyframeStartnew = false;
      keyframe1new = false;
      keyframe2new = false;
      keyframe3new = false;
      keyframeEndnew = false;
      break;

    case 4020:
      v7[0] = BTvalue.toInt();
      v7[2] = BTvalue.toInt();
      break;

    case 4021:
      v7[3] = BTvalue.toInt();
      break;

    case 4022:
      v7[4] = BTvalue.toInt();
      v7[6] = BTvalue.toInt();
      break;

    case 4023:
      v7[5] = BTvalue.toInt();
      keyframeStartnew = false;
      keyframe1new = false;
      keyframe2new = false;
      keyframe3new = false;
      keyframeEndnew = false;
      break;

    case 4030:
      w7[0] = BTvalue.toInt();
      w7[2] = BTvalue.toInt();
      break;

    case 4031:
      w7[3] = BTvalue.toInt();
      break;

    case 4032:
      w7[4] = BTvalue.toInt();
      w7[6] = BTvalue.toInt();
      break;

    case 4033:
      w7[5] = BTvalue.toInt();
      keyframeStartnew = false;
      keyframe1new = false;
      keyframe2new = false;
      keyframe3new = false;
      keyframeEndnew = false;
      break;

    case 4040:
      x7[0] = BTvalue.toInt();
      x7[2] = BTvalue.toInt();
      break;

    case 4041:
      x7[3] = BTvalue.toInt();
      break;

    case 4042:
      x7[4] = BTvalue.toInt();
      x7[6] = BTvalue.toInt();
      break;

    case 4043:
      x7[5] = BTvalue.toInt();
      keyframeStartnew = false;
      keyframe1new = false;
      keyframe2new = false;
      keyframe3new = false;
      keyframeEndnew = false;
      break;

    case 4050:
      y7[0] = BTvalue.toInt();
      y7[2] = BTvalue.toInt();
      break;

    case 4051:
      y7[3] = BTvalue.toInt();
      break;

    case 4052:
      y7[4] = BTvalue.toInt();
      y7[6] = BTvalue.toInt();
      break;

    case 4053:
      y7[5] = BTvalue.toInt();
      keyframeStartnew = false;
      keyframe1new = false;
      keyframe2new = false;
      keyframe3new = false;
      keyframeEndnew = false;
      break;

    case 4060:
      z7[0] = BTvalue.toInt();
      z7[2] = BTvalue.toInt();
      break;

    case 4061:
      z7[3] = BTvalue.toInt();
      break;

    case 4062:
      z7[4] = BTvalue.toInt();
      z7[6] = BTvalue.toInt();
      break;

    case 4063:
      z7[5] = BTvalue.toInt();
      keyframeStartnew = false;
      keyframe1new = false;
      keyframe2new = false;
      keyframe3new = false;
      keyframeEndnew = false;
      break;

    case 5001:
      AccelStepperU.moveTo(BTvalue.toInt());
      AccelStepperY.moveTo(AccelStepperY.currentPosition());
      AccelStepperZ.moveTo(AccelStepperZ.currentPosition());
      AccelStepperX.moveTo(AccelStepperX.currentPosition());
      AccelStepperV.moveTo(AccelStepperV.currentPosition());
      AccelStepperW.moveTo(AccelStepperW.currentPosition());

      switch (currentKeyframe) {
        case 0:
          break;

        case 1:
          u7[0] = BTvalue.toInt();
          u7[2] = BTvalue.toInt();
          break;

        case 2:
          u7[3] = BTvalue.toInt();
          break;

        case 3:
          u7[4] = BTvalue.toInt();
          u7[6] = BTvalue.toInt();
          break;

        case 4:
          u7[5] = BTvalue.toInt();
          break;

      }
      if (keyframeMovement == true) {
        moveKeyframe = true;
      } else {
        myString = String(BTvalue.toInt());
        StringSend = "#curPosU_" + myString + "$";
        Serial5.print(StringSend);

        delay(40);
        myString = String(AccelStepperV.currentPosition());
        StringSend = "#curPosV_" + myString + "$";
        Serial5.print(StringSend);

        delay(40);
        myString = String(AccelStepperW.currentPosition());
        StringSend = "#curPosW_" + myString + "$";
        Serial5.print(StringSend);

        delay(40);
        myString = String(AccelStepperX.currentPosition());
        StringSend = "#curPosX_" + myString + "$";
        Serial5.print(StringSend);

        delay(40);
        myString = String(AccelStepperY.currentPosition());
        StringSend = "#curPosY_" + myString + "$";
        Serial5.print(StringSend);

        delay(40);
        myString = String(AccelStepperZ.currentPosition());
        StringSend = "#curPosZ_" + myString + "$";
        Serial5.print(StringSend);

        delay(40);
        myString = "0";
        StringSend = "#keyframeReached_" + myString + "$";
        Serial5.print(StringSend);



      }
      break;

    case 5002:
      AccelStepperV.moveTo(BTvalue.toInt());
      AccelStepperY.moveTo(AccelStepperY.currentPosition());
      AccelStepperZ.moveTo(AccelStepperZ.currentPosition());
      AccelStepperU.moveTo(AccelStepperU.currentPosition());
      AccelStepperX.moveTo(AccelStepperX.currentPosition());
      AccelStepperW.moveTo(AccelStepperW.currentPosition());
      switch (currentKeyframe) {
        case 0:
          break;

        case 1:
          v7[0] = BTvalue.toInt();
          v7[2] = BTvalue.toInt();
          break;

        case 2:
          v7[3] = BTvalue.toInt();
          break;

        case 3:
          v7[4] = BTvalue.toInt();
          v7[6] = BTvalue.toInt();
          break;

        case 4:
          v7[5] = BTvalue.toInt();
          break;

      }
      if (keyframeMovement == true) {
        moveKeyframe = true;
      }
      else {
        myString = String(AccelStepperU.currentPosition());
        StringSend = "#curPosU_" + myString + "$";
        Serial5.print(StringSend);

        delay(40);
        myString = String(BTvalue.toInt());
        StringSend = "#curPosV_" + myString + "$";
        Serial5.print(StringSend);

        delay(40);
        myString = String(AccelStepperW.currentPosition());
        StringSend = "#curPosW_" + myString + "$";
        Serial5.print(StringSend);

        delay(40);
        myString = String(AccelStepperX.currentPosition());
        StringSend = "#curPosX_" + myString + "$";
        Serial5.print(StringSend);

        delay(40);
        myString = String(AccelStepperY.currentPosition());
        StringSend = "#curPosY_" + myString + "$";
        Serial5.print(StringSend);

        delay(40);
        myString = String(AccelStepperZ.currentPosition());
        StringSend = "#curPosZ_" + myString + "$";
        Serial5.print(StringSend);

        delay(40);
        myString = "0";
        StringSend = "#keyframeReached_" + myString + "$";
        Serial5.print(StringSend);



      }
      break;

    case 5003:
      AccelStepperW.moveTo(BTvalue.toInt());
      AccelStepperY.moveTo(AccelStepperY.currentPosition());
      AccelStepperZ.moveTo(AccelStepperZ.currentPosition());
      AccelStepperU.moveTo(AccelStepperU.currentPosition());
      AccelStepperV.moveTo(AccelStepperV.currentPosition());
      AccelStepperX.moveTo(AccelStepperX.currentPosition());
      switch (currentKeyframe) {
        case 0:
          break;

        case 1:
          w7[0] = BTvalue.toInt();
          w7[2] = BTvalue.toInt();
          break;

        case 2:
          w7[3] = BTvalue.toInt();
          break;

        case 3:
          w7[4] = BTvalue.toInt();
          w7[6] = BTvalue.toInt();
          break;

        case 4:
          w7[5] = BTvalue.toInt();
          break;

      }
      if (keyframeMovement == true) {
        moveKeyframe = true;
      }
      else {
        myString = String(AccelStepperU.currentPosition());
        StringSend = "#curPosU_" + myString + "$";
        Serial5.print(StringSend);

        delay(40);
        myString = String(AccelStepperV.currentPosition());
        StringSend = "#curPosV_" + myString + "$";
        Serial5.print(StringSend);

        delay(40);
        myString = String(BTvalue.toInt());
        StringSend = "#curPosW_" + myString + "$";
        Serial5.print(StringSend);

        delay(40);
        myString = String(AccelStepperX.currentPosition());
        StringSend = "#curPosX_" + myString + "$";
        Serial5.print(StringSend);

        delay(40);
        myString = String(AccelStepperY.currentPosition());
        StringSend = "#curPosY_" + myString + "$";
        Serial5.print(StringSend);

        delay(40);
        myString = String(AccelStepperZ.currentPosition());
        StringSend = "#curPosZ_" + myString + "$";
        Serial5.print(StringSend);

        delay(40);
        myString = "0";
        StringSend = "#keyframeReached_" + myString + "$";
        Serial5.print(StringSend);



      }
      break;

    case 5004:
      AccelStepperX.moveTo(BTvalue.toInt());
      AccelStepperY.moveTo(AccelStepperY.currentPosition());
      AccelStepperZ.moveTo(AccelStepperZ.currentPosition());
      AccelStepperU.moveTo(AccelStepperU.currentPosition());
      AccelStepperV.moveTo(AccelStepperV.currentPosition());
      AccelStepperW.moveTo(AccelStepperW.currentPosition());
      switch (currentKeyframe) {
        case 0:
          break;

        case 1:
          x7[0] = BTvalue.toInt();
          x7[2] = BTvalue.toInt();
          break;

        case 2:
          x7[3] = BTvalue.toInt();
          break;

        case 3:
          x7[4] = BTvalue.toInt();
          x7[6] = BTvalue.toInt();
          break;

        case 4:
          x7[5] = BTvalue.toInt();
          break;

      }
      if (keyframeMovement == true) {
        moveKeyframe = true;
      }
      else {
        myString = String(AccelStepperU.currentPosition());
        StringSend = "#curPosU_" + myString + "$";
        Serial5.print(StringSend);

        delay(40);
        myString = String(AccelStepperV.currentPosition());
        StringSend = "#curPosV_" + myString + "$";
        Serial5.print(StringSend);

        delay(40);
        myString = String(AccelStepperW.currentPosition());
        StringSend = "#curPosW_" + myString + "$";
        Serial5.print(StringSend);

        delay(40);
        myString = String(BTvalue.toInt());
        StringSend = "#curPosX_" + myString + "$";
        Serial5.print(StringSend);

        delay(40);
        myString = String(AccelStepperY.currentPosition());
        StringSend = "#curPosY_" + myString + "$";
        Serial5.print(StringSend);

        delay(40);
        myString = String(AccelStepperZ.currentPosition());
        StringSend = "#curPosZ_" + myString + "$";
        Serial5.print(StringSend);

        delay(40);
        myString = "0";
        StringSend = "#keyframeReached_" + myString + "$";
        Serial5.print(StringSend);



      }
      break;

    case 5005:
      AccelStepperY.moveTo(BTvalue.toInt());
      AccelStepperX.moveTo(AccelStepperX.currentPosition());
      AccelStepperZ.moveTo(AccelStepperZ.currentPosition());
      AccelStepperU.moveTo(AccelStepperU.currentPosition());
      AccelStepperV.moveTo(AccelStepperV.currentPosition());
      AccelStepperW.moveTo(AccelStepperW.currentPosition());
      switch (currentKeyframe) {
        case 0:
          break;

        case 1:
          y7[0] = BTvalue.toInt();
          y7[2] = BTvalue.toInt();
          break;

        case 2:
          y7[3] = BTvalue.toInt();
          break;

        case 3:
          y7[4] = BTvalue.toInt();
          y7[6] = BTvalue.toInt();
          break;

        case 4:
          y7[5] = BTvalue.toInt();
          break;

      }
      if (keyframeMovement == true) {
        moveKeyframe = true;
      }
      else {
        myString = String(AccelStepperU.currentPosition());
        StringSend = "#curPosU_" + myString + "$";
        Serial5.print(StringSend);

        delay(40);
        myString = String(AccelStepperV.currentPosition());
        StringSend = "#curPosV_" + myString + "$";
        Serial5.print(StringSend);

        delay(40);
        myString = String(AccelStepperW.currentPosition());
        StringSend = "#curPosW_" + myString + "$";
        Serial5.print(StringSend);

        delay(40);
        myString = String(AccelStepperX.currentPosition());
        StringSend = "#curPosX_" + myString + "$";
        Serial5.print(StringSend);

        delay(40);
        myString = String(BTvalue.toInt());
        StringSend = "#curPosY_" + myString + "$";
        Serial5.print(StringSend);

        delay(40);
        myString = String(AccelStepperZ.currentPosition());
        StringSend = "#curPosZ_" + myString + "$";
        Serial5.print(StringSend);

        delay(40);
        myString = "0";
        StringSend = "#keyframeReached_" + myString + "$";
        Serial5.print(StringSend);



      }
      break;

    case 5006:
      AccelStepperZ.moveTo(BTvalue.toInt());
      AccelStepperY.moveTo(AccelStepperY.currentPosition());
      AccelStepperX.moveTo(AccelStepperX.currentPosition());
      AccelStepperU.moveTo(AccelStepperU.currentPosition());
      AccelStepperV.moveTo(AccelStepperV.currentPosition());
      AccelStepperW.moveTo(AccelStepperW.currentPosition());
      switch (currentKeyframe) {
        case 0:
          break;

        case 1:
          z7[0] = BTvalue.toInt();
          z7[2] = BTvalue.toInt();
          break;

        case 2:
          z7[3] = BTvalue.toInt();
          break;

        case 3:
          z7[4] = BTvalue.toInt();
          z7[6] = BTvalue.toInt();
          break;

        case 4:
          z7[5] = BTvalue.toInt();
          break;

      }

      if (keyframeMovement == true) {
        moveKeyframe = true;
      }
      else {
        myString = String(AccelStepperU.currentPosition());
        StringSend = "#curPosU_" + myString + "$";
        Serial5.print(StringSend);

        delay(40);
        myString = String(AccelStepperV.currentPosition());
        StringSend = "#curPosV_" + myString + "$";
        Serial5.print(StringSend);

        delay(40);
        myString = String(AccelStepperW.currentPosition());
        StringSend = "#curPosW_" + myString + "$";
        Serial5.print(StringSend);

        delay(40);
        myString = String(AccelStepperX.currentPosition());
        StringSend = "#curPosX_" + myString + "$";
        Serial5.print(StringSend);

        delay(40);
        myString = String(AccelStepperY.currentPosition());
        StringSend = "#curPosY_" + myString + "$";
        Serial5.print(StringSend);

        delay(40);
        myString = String(BTvalue.toInt());
        StringSend = "#curPosZ_" + myString + "$";
        Serial5.print(StringSend);

        delay(40);
        myString = "0";
        StringSend = "#keyframeReached_" + myString + "$";
        Serial5.print(StringSend);



      }
      break;

    case 5100:
      {
        int panoPause = BTvalue.toInt();
        if (panoPause == 0) {
          pausePano = true;
        }
        else if (panoPause == 1) {
          digitalWrite(dslrFocus, HIGH);
          delay(100);
          digitalWrite(dslrFocus, LOW);
          delay(600);
          pausePano = false;
          startPano = true;
          //  Serial.println("panoPausefalse");
          previousMillis = millis();
        }
        else {
          digitalWrite(dslrFocus, HIGH);
          delay(100);
          digitalWrite(dslrFocus, LOW);
          delay(600);
          pausePano = false;
          startPanoVertical = true;
          //  Serial.println("panoPausefalse");
          previousMillis = millis();
        }
      }
      break;


    case 5101:
      {
        int tlPause = BTvalue.toInt();
        if (tlPause == 1) {
          pauseTL = true;
        } else {
          digitalWrite(dslrFocus, HIGH);
          delay(100);
          digitalWrite(dslrFocus, LOW);
          delay(600);
          pauseTL = false;
          previousMillis = millis();
        }
      }
      break;

    case 5200:
      if (PS4.connected()) {
        if (BTvalue.toInt() == 1 && PS4.getBatteryLevel() < 5) {
          myString = String(PS4.getBatteryLevel());
          StringSend = "#ps4bat_" + myString + "$";
          Serial5.print(StringSend);
        }
      }

      if (BTvalue.toInt() == 0) {
        myString = String(PS4.getBatteryLevel());
        StringSend = "#ps4bat_" + myString + "$";
        Serial5.print(StringSend);
      }

      break;

    case 5300:




      if (BTvalue.toInt() == 1) {
        //    Serial.println("Backlash-Prozess START");
        backlashprocess();
        //   Serial.println("Backlash-Prozess END");
        startAstro = true;
      }
      else {


        startAstro = false;
      }
      break;
    case 5301:
      AstroPicRepete = BTvalue.toInt();
      break;
    case 5302:
      AstroExpoTime01 = BTvalue.toInt();
      break;
    case 5303:
      AstroExpoTime02 = BTvalue.toInt();
      break;
    case 5304:
      AstroExpoTime03 = BTvalue.toInt();
      break;
    case 5305:
      AstroExpo01delay = BTvalue.toInt();
      break;
    case 5306:
      AstroExpo02delay = BTvalue.toInt();
      break;
    case 5307:
      AstroExpo03delay = BTvalue.toInt();
      break;

    case 5310:
      astroPicActive = true;
      //Serial.println("halli");

      break;
    case 5320:
      AstroObject = BTvalue.toInt();

      break;


    case 6000:
      if (BTvalue.toInt() == 0) {
        keyframeMovement = false;
      }
      else {
        keyframeMovement = true;
      }

      break;

    case 7000:


      //getcurrentpositions
      myString = String((long)u7[5]);
      StringSend = "#curPosU_" + myString + "$";
      Serial5.print(StringSend);
      //  Serial.println(StringSend);
      delay(30);
      myString = String((long)v7[5]);
      StringSend = "#curPosV_" + myString + "$";
      Serial5.print(StringSend);
      // Serial.println(StringSend);
      delay(30);
      myString = String((long)w7[5]);
      StringSend = "#curPosW_" + myString + "$";
      Serial5.print(StringSend);
      // Serial.println(StringSend);
      delay(30);
      myString = String((long)x7[5]);
      StringSend = "#curPosX_" + myString + "$";
      Serial5.print(StringSend);
      // Serial.println(StringSend);
      delay(30);
      myString = String((long)y7[5]);
      StringSend = "#curPosY_" + myString + "$";
      Serial5.print(StringSend);
      // Serial.println(StringSend);
      delay(30);
      myString = String((long)z7[5]);
      StringSend = "#curPosZ_" + myString + "$";
      Serial5.print(StringSend);
      //Serial.println(StringSend);
      delay(30);
      break;

  }
}

void returnvalues() {

  int intervalsend = TLinterval / 1000;
  myString = String(intervalsend);
  StringSend = "#interval_" + myString + "$";
  Serial5.print(StringSend);

  delay(50);
  myString = String(totalPicNo);
  StringSend = "#totalPicNo_" + myString + "$";
  Serial5.print(StringSend);

  delay(50);
  myString = String(currentPicNo);
  StringSend = "#currentPicNo_" + myString + "$";
  Serial5.print(StringSend);

}


uint8_t tmc_write(int axis, uint8_t cmd, uint32_t data)
{
  uint8_t s;

  //  Serial.println("SPI------------------------------");
  // Serial.println(data);

  SPI.beginTransaction(settingsA);
  switch (axis) {
    case 1:
      digitalWrite(Xcs, LOW);
      break;
    case 2:
      digitalWrite(Ycs, LOW);
      break;
    case 3:
      digitalWrite(Zcs, LOW);
      break;
    case 4:
      digitalWrite(Ucs, LOW);
      break;
    case 5:
      digitalWrite(Vcs, LOW);
      break;
    case 6:
      digitalWrite(Wcs, LOW);
      break;
  }


  s = SPI.transfer(cmd);
  SPI.transfer((data >> 24UL) & 0xFF) & 0xFF;
  SPI.transfer((data >> 16UL) & 0xFF) & 0xFF;
  SPI.transfer((data >> 8UL) & 0xFF) & 0xFF;
  SPI.transfer((data >> 0UL) & 0xFF) & 0xFF;

  switch (axis) {
    case 1:
      digitalWrite(Xcs, HIGH);
      break;
    case 2:
      digitalWrite(Ycs, HIGH);
      break;
    case 3:
      digitalWrite(Zcs, HIGH);
      break;
    case 4:
      digitalWrite(Ucs, HIGH);
      break;
    case 5:
      digitalWrite(Vcs, HIGH);
      break;
    case 6:
      digitalWrite(Wcs, HIGH);
      break;
  }
  SPI.endTransaction();
  return s;
}


